<!DOCTYPE html>
<html>
<head>
<title> Save Dino</title>
<style>
  canvas {
    background:url(volcano-background.jpg);
  }
  .p1 {
    font-family: 'Courier New', Courier, monospace;
    font-size: 25px;
    font-weight: 1000;
    margin-left: 15%;
    text-align: left;
  }
  .p2 {
    font-family: 'Courier New', Courier, monospace;
    font-size: 18px;
    font-weight: 800;
    margin-left: 15%;
    text-align: left;
  }
</style>
</head>
<body>
<canvas id="canvas"></canvas>
  <div>
    <p class="p1"> Save Dino from Extinction!
    </p>
    <p class="p2">
      Use the arrow keys to move the dino. Catch the flower to score points!
    </p>
    <p class="p1">
      <a href="javascript:window.location.href=window.location.href"> Try again! </a>
    </p>
  </div>
<script>

var canvas = document.querySelector("canvas");
var context = canvas.getContext("2d");
canvas.width = 1250;
canvas.height = 625;
var canvasWidth = canvas.width; // max x
var canvasHeight = canvas.height; // max y

var player;
var attacker;
var flower;

// keycode movements for player
var keyState = [];
const keyUp = 38;
const keyDown = 40;
const keyLeft = 37;
const keyRight = 39;
var moveSpeed = 10;

var score = 0;
var level = 1;

var xFlowerSpeed = 5;
var yFlowerSpeed = 5;

var dinoImage = new Image();
var asteroidImage = new Image();
var flowerImage = new Image();
var scoreBoard = new Image();

var xFlower;
var yFlower;

function randomNumber(min, max) {
return Math.random() * (max - min) + min;
}

function init() {
  dinoImage.src = "dino2.png";
  asteroidImage.src = "asteroid.png";
  flowerImage.src = "flower.png";
}

function startGame() {
  player = new createPlayer(120, 100, 500, 400); // width, height, x, y
  attacker = new createAttacker(120, 100, randomNumber(150,1000), randomNumber(150,500)); // width, height, x, y
  flower = new createFlower(80,80,1000,400); // width, height, x, y
  scoreBoard = new createScoreBoard(200,55,900,150); // width, height, x, y
}

function stopGame() {
  moveSpeed = 0;
  xAttackSpeed = 0;
  yAttackSpeed = 0;
  xFlowerSpeed = 0;
  yFlowerSpeed = 0;
  context.fill();
  context.font = "50px Courier New";
  context.fillStyle = "red";
  context.fillText("GAME OVER",500,200);
}

startGame();

function animate() {
  ctx = context;
  ctx.clearRect(0,0,canvasWidth,canvasHeight);
  player.draw();
  attacker.draw();
  flower.draw();
  scoreBoard.draw();
  player.move();
  attacker.move();
  flower.move();
  attacker.speed();
  // console.log("attack speed, x, y", xAttackSpeed, yAttackSpeed, "\n flower speed, x, y", xFlowerSpeed, yFlowerSpeed);

  scorePoints();
  detectCollision();
  requestAnimationFrame(animate);
}

function createScoreBoard(width, height, x, y) {
  this.width = width;
  this.height = height;
  this.x = x;
  this.y = y;
  this.draw = function() {
  ctx = context;
  ctx.drawImage(dinoImage, this.x, this.y, this.width, this.height);
  ctx.fillStyle = "yellow";
  ctx.fillRect(this.x, this.y, this.width, this.height);
  context.fill();
  context.font = "25px Courier New ";
  context.fillStyle = "black";
  context.fillText("SCORE:",this.x,this.y+25);
  context.fillText(score,this.x,this.y+50);
  context.fillText("LEVEL:",this.x+100,this.y+25);
  context.fillText(level,this.x+100,this.y+50);
  }
}


function createPlayer(width, height, x, y) {
  this.width = width;
  this.height = height;
  this.x = x;
  this.y = y;
  this.draw = function() {
  ctx = context;
  ctx.drawImage(dinoImage, this.x, this.y, this.width, this.height);
  //  ctx.fillStyle = "yellow";
  //  ctx.fillRect(this.x, this.y, this.width, this.height);
  }

  // move the player:
  this.move = function() {
    if (keyState[keyUp] && this.y >0) {
      this.y -= moveSpeed;
    }
    if (keyState[keyDown] && this.y <canvasHeight-height) {
      this.y += moveSpeed;
    }
    if (keyState[keyLeft] && this.x >0) {
      this.x -= moveSpeed;
    }
    if (keyState[keyRight] && this.x <canvasWidth-width) {
      this.x += moveSpeed;
    }
  }
}

// attack levels
// level 1: score < 25
var xAttackSpeed = 8;
var yAttackSpeed = 8;

function createAttacker(width, height, x, y) {
  this.width = width;
  this.height = height;
  this.x = x;
  this.y = y;
  this.draw = function() {
    ctx = context;
    ctx.drawImage(asteroidImage, this.x, this.y, this.width, this.height);
    //  ctx.fillStyle = "red";
    //  ctx.fillRect(this.x, this.y, this.width, this.height);
  }
  // move the attacker:
  this.move = function() {
            if (
              (this.x + this.width > canvasWidth) ||
            (this.x < 0)) {
              xAttackSpeed = -xAttackSpeed;
            }
            if (
              (this.y + this.height > canvasHeight) ||
              (this.y < 0)) {
              yAttackSpeed = -yAttackSpeed;
            }
          this.x += xAttackSpeed;
          this.y += yAttackSpeed;
        }

    this.speed = function() {
      // level 2
      if (score >=25 && score < 50) {
        if (xAttackSpeed < 0) {
          xAttackSpeed = -11;
        }
        if (xAttackSpeed > 0) {
          xAttackSpeed = 11;
        }
        if (yAttackSpeed < 0) {
          yAttackSpeed = -13;
        }
        if (yAttackSpeed > 0) {
          yAttackSpeed = 13;
        }
      }
      // level 3
      if (score >=50 && score < 75) {
        if (xAttackSpeed < 0) {
          xAttackSpeed = -15;
        }
        if (xAttackSpeed > 0) {
          xAttackSpeed = 15;
        }
        if (yAttackSpeed < 0) {
          yAttackSpeed = -14;
        }
        if (yAttackSpeed > 0) {
          yAttackSpeed = 14;
        }
      }
      // level 4
      if (score >=75) {
        if (xAttackSpeed < 0) {
          xAttackSpeed = -15;
        }
        if (xAttackSpeed > 0) {
          xAttackSpeed = 18;
        }
        if (yAttackSpeed < 0) {
          yAttackSpeed = -18;
        }
        if (yAttackSpeed > 0) {
          yAttackSpeed = 15;
        }
      }
    }

}

function createFlower(width, height, x, y) {
  this.width = width;
  this.height = height;
  this.x = x;
  this.y = y;
  this.draw = function() {
    ctx = context;
    ctx.drawImage(flowerImage, this.x, this.y, this.width, this.height);
  }

  // move the flower: 4 turns
  this.move = function() {

    // level 1
    if (score < 25) {
      // bottom right
      if (
        (this.x + this.width >= 1200) && (this.y + this.height >= 600)) {
          xFlowerSpeed = -5;
          yFlowerSpeed = 0;
        }

    // top right
    if (
        (this.x + this.width >= 1200) && (this.y <= 100)) {
          xFlowerSpeed = 0;
          yFlowerSpeed = 5;
        }

    // top left
     if(
      (this.x <= 100) && (this.y <= 100)) {
        xFlowerSpeed = 5;
        yFlowerSpeed = 0;
      }

    // bottom left
      if (
        (this.y + this.height >= 600) && (this.x <= 100)) {
          yFlowerSpeed = -5;
          xFlowerSpeed = 0;
        }
    }

    // level 2
    if (score >= 25 && score < 50) {
      // bottom right
      if (
        (this.x + this.width >= 1200) && (this.y + this.height >= 600)) {
          xFlowerSpeed = 0;
          yFlowerSpeed = -7;
        }

    // top right
    if (
        (this.x + this.width >= 1200) && (this.y <= 100)) {
          xFlowerSpeed = -7;
          yFlowerSpeed = 0;
        }

    // top left
     if(
      (this.x <= 100) && (this.y <= 100)) {
        xFlowerSpeed = 0;
        yFlowerSpeed = 7;
      }

    // bottom left
      if (
        (this.y + this.height >= 600) && (this.x <= 100)) {
          yFlowerSpeed = 0;
          xFlowerSpeed = 7;
        }
    }

    // level 3
    if (score >= 50 && score < 75) {
      // bottom right
      if (
        (this.x + this.width >= 1200) && (this.y + this.height >= 600)) {
          xFlowerSpeed = -9;
          yFlowerSpeed = 0;
        }

    // top right
    if (
        (this.x + this.width >= 1200) && (this.y <= 100)) {
          xFlowerSpeed = 0;
          yFlowerSpeed = 9;
        }

    // top left
     if(
      (this.x <= 100) && (this.y <= 100)) {
        xFlowerSpeed = 9;
        yFlowerSpeed = 0;
      }

    // bottom left
      if (
        (this.y + this.height >= 600) && (this.x <= 100)) {
          yFlowerSpeed = -9;
          xFlowerSpeed = 0;
        }
    }

    // level 4
    if (score >= 75) {
     // bottom right
     if (
        (this.x + this.width >= 1200) && (this.y + this.height >= 600)) {
          xFlowerSpeed = -11;
          yFlowerSpeed = 0;
        }

    // top right
    if (
        (this.x + this.width >= 1200) && (this.y <= 100)) {
          xFlowerSpeed = 0;
          yFlowerSpeed = 11;
        }

    // top left
     if(
      (this.x <= 100) && (this.y <= 100)) {
        xFlowerSpeed = 11;
        yFlowerSpeed = 0;
      }

    // bottom left
      if (
        (this.y + this.height >= 600) && (this.x <= 100)) {
          yFlowerSpeed = -11;
          xFlowerSpeed = 0;
        }
    }

    // general movement
    this.x += xFlowerSpeed;
    this.y += yFlowerSpeed;
    }
  }

function scorePoints() {
// ADD SCORE POINTS FOR COLLECTING THE FLOWER
// MOVE FLOWER AT RANDOM AFTER COLLECTING IT
var xPlayerCenter = player.x + 50;
var xFlowerCenter = flower.x + 50;
var yPlayerCenter = player.y + 50;
var yFlowerCenter = flower.y + 50;
// console.log(xPlayerCenter,xFlowerCenter,yPlayerCenter,yFlowerCenter);
  if (
    (xPlayerCenter <= xFlowerCenter + 50 &&
    xPlayerCenter >= xFlowerCenter - 50) &&
    (yPlayerCenter <= yFlowerCenter + 50 &&
    yPlayerCenter >= yFlowerCenter - 50)
  ) {
    score ++;
    flower.x = randomNumber(200, 1100);
    flower.y = randomNumber(200, 500);

    // changes direction of flower after scoring
    if (score % 2 == 0 || score % 5 == 0) {
      xFlowerSpeed = 6;
      yFlowerSpeed = -6;
    }
    else {
      xFlowerSpeed = -6;
      yFlowerSpeed = 6;
    }

    // level 2
    if (score >= 25 && score < 50) {
      level = 2;
    }
    // level 3
    if (score >= 50 && score < 75) {
      level = 3;
    }
    // level 4
    if (score >= 75) {
      level = 4;
    }
  }
}


function detectCollision() {
var xPlayerCenter = player.x + 50;
var xAttackerCenter = attacker.x + 50;
var yPlayerCenter = player.y + 50;
var yAttackerCenter = attacker.y + 50;
// console.log(xPlayerCenter,xAttackerCenter,yPlayerCenter,yAttackerCenter);
  if (
    (xPlayerCenter <= xAttackerCenter + 50 &&
    xPlayerCenter >= xAttackerCenter - 50) &&
    (yPlayerCenter <= yAttackerCenter + 50 &&
    yPlayerCenter >= yAttackerCenter - 50)
    ) {
    stopGame();
  }
}

requestAnimationFrame(animate);

init();

// create a logging function to move the player
const keyEventLogger = function(e) {
  keyState[e.keyCode] = e.type == "keydown";
}
window.addEventListener("keydown", keyEventLogger);
window.addEventListener("keyup", keyEventLogger);

</script>
</body>
</html>
